//SeitenEntfernen_02d.js
// 28.10.2018 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//DESCRIPTION:Markierte Seiten entfernen

// vorbeugenderweise das Anzeigen von Dialogen aktivieren
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// testen, ob ein Dokument geffnet ist
if (app.documents.length == 0) {
	alert ("Es ist kein Dokument offen.", "Achtung");
	exit();
}

// aktuelles Dokument
var curDoc = app.documents[0];

// die Suchen/Ersetzen-Vorgaben zurcksetzen
app.findGrepPreferences = app.changeGrepPreferences = null;
app.findTextPreferences = app.changeTextPreferences = null;

// zuerst die "XX,XX" //////////////////////////////////////////////
// das Suchmuster vorbereiten
app.findTextPreferences.findWhat = "XX,XX";

// die Vorkommen finden und zhlen
var allFound = curDoc.findText();
var nFound   = allFound.length;
var namesArr = [];

// eine Schleife durch die Vorkommen und die Seitennamen auflisten
for (var n=0; n<nFound; n++) {
	var curName = allFound[n].parentTextFrames[0].parentPage.name;
	var isInArr = checkName(namesArr, curName);
	if (!isInArr) {
		namesArr.push(curName);
	}
}

// den Array sortieren ...
namesArr.sort(numSort);
// ... umkehren ...
namesArr.reverse();
// ... und zhlen
var nNames = namesArr.length;

// die Seiten entfernen
for (var p=0; p<nNames; p++) {
	try {
		curDoc.pages.itemByName(namesArr[p]).remove();
	}
	catch (e) {
	}
}

// und nun die Seiten mit einem Betrag /////////////////////////////
// das Suchmuster vorbereiten
app.findGrepPreferences.findWhat = "[0-9]+,[0-9]{2}";

// die Vorkommen finden und zhlen
var allFound = curDoc.findGrep();
var nFound   = allFound.length;
var namesArr = [];

// eine Schleife durch die Vorkommen und die Seitennamen auflisten
for (var n=0; n<nFound; n++) {
	var curName = allFound[n].parentTextFrames[0].parentPage.name;
	var nxtName = ""+((curName*1)+1);
	var isInArr = checkName(namesArr, nxtName);
	if (!isInArr) {
		namesArr.push(nxtName);
	}
}

// den Array sortieren ...
namesArr.sort(numSort);
// ... umkehren ...
namesArr.reverse();
// ... und zhlen
var nNames = namesArr.length;

// die Seiten entfernen
for (var p=0; p<nNames; p++) {
	try {
		curDoc.pages.itemByName(namesArr[p]).remove();
	}
	catch (e) {
	}
}

// die Suchen/Ersetzen-Vorgaben zurcksetzen
app.findGrepPreferences = app.changeGrepPreferences = null;
app.findTextPreferences = app.changeTextPreferences = null;

////////////////////////////////////////////////////////////////////
// das Ende der Aktion verknden
var dlog = new Window("palette");
dlog.size = [320,100];
dlog.add("statictext", [80, 100, 320, 116], "Fertig.");
dlog.show();
// eine kleine Pause
$.sleep(999);
// das Fenster schliessen
dlog.close();

////////////////////////////////////////////////////////////////////
// diese Funktion prft, ob sich der Name schon im Array befindet
function checkName(namesArr, curName) {
	for (var n=0; n<namesArr.length; n++) {
		if (namesArr[n] == curName) {
			return true;
		}
	}
	return false;
}

////////////////////////////////////////////////////////////////////
// die Funktion, welche Zahlen-Strings sortiert
function numSort(a, b) {
	return a - b;
}